local M={}
M.tbl = {}
M.adrtbl = {}
M.pin = 4

function M.setup(dq)
    M.pin = dq or 4
end

function M.addrs(call)
    M.adrtbl = {}
    ow.setup(M.pin)
    ow.reset_search(M.pin)
    local adr
    repeat
        adr = ow.search(M.pin)
        if(adr ~= nil) then
            table.insert(M.adrtbl, adr)
        end
        tmr.wdclr()
    until (adr == nil)
    ow.reset_search(M.pin)
    adr = nil
    M.askT(call)
    return #M.adrtbl
end

function M.askT(call)
    ow.setup(M.pin)
    for _, v in pairs(M.adrtbl) do
        ow.reset(M.pin)
        ow.select(M.pin, v)
        ow.write(M.pin, 0x44, 1)
        tmr.wdclr()
    end
    v = nil
    if call then call() end
end

function M.readResult(call, temptabl)    
    local result = {}
    local data
    local crc
    local t
    for _, v in pairs(M.adrtbl) do
        ow.reset(M.pin)
        ow.select(M.pin, v)
        ow.write(M.pin,0xBE,1)
        data = string.char(ow.read(M.pin))
        for i = 1, 8 do
            data = data .. string.char(ow.read(M.pin))
        end
        crc = ow.crc8(string.sub(data,1,8))
        if (crc == data:byte(9)) then
            t = (data:byte(1) + data:byte(2) * 256)
            if (t > 32767) then t = t - 65536 end
            t = t * 625 /10000
            table.insert(result, t)
        end
        tmr.wdclr()
    end
    data = nil
    crc = nil
    t = nil
    if temptabl then temptabl = result end
    if call then 
        M.tbl = nil
        M.adrtbl = nil
        M.pin = nil
        M.setup = nil
        M.askT = nil
        M.readResult = nil
        call() 
    end
    return result
end
return M
